#include <sys/limits.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <err.h>
#include <sysexits.h>

int main(int argc, char *argv[])
{
	struct timespec	pre, cur;
	useconds_t d, dmin, dmax, dsum;
	int dweird = 0;
	int i, loop;

	if (argc != 2) {
		fprintf(stderr, "timecheck <loop>\n");
		return EXIT_FAILURE;
	}

	loop = atoi(argv[1]);
	dmax = dsum = 0;
	dmin = UINT_MAX;

	fprintf(stdout, "looping %d times...\n", loop);

	for (i = 0; i < loop; i++) {

		if (clock_gettime(CLOCK_MONOTONIC, &pre) < 0)
			err(EX_OSERR, NULL);

		if (clock_gettime(CLOCK_MONOTONIC, &cur) < 0)
			err(EX_OSERR, NULL);

		d = (cur.tv_sec - pre.tv_sec) * 1000000;
		d = d + (cur.tv_nsec / 1000) - (pre.tv_nsec / 1000);

		dsum += d;
		if (d < dmin)
			dmin = d;
		if (d > dmax)
			dmax = d;
		if (d > 10*1000) /* 10 ms */
			dweird++;

		cur = pre;
	}

	fprintf(stdout, "dmin  = %dus\ndmax  = %dus\ndmean = %dus\ndweird = %d\n",
			dmin, dmax, dsum / loop, dweird);
	return 0;
}



